package ru.myitschool.work.data.remote

import okhttp3.ResponseBody
import retrofit2.Response
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.PATCH
import retrofit2.http.Path
import retrofit2.http.Query

interface LoginApi {
  @GET("auth")
  suspend fun auth(
    @Header("Authorization") authHeader: String,
    @Query("login") login: String
  ): Response<ResponseBody>

  @GET("info")
  suspend fun info(
    @Header("Authorization") authHeader: String,
    @Query("login") login: String
  ): Response<ResponseBody>

  @PATCH("{login}/open")
  suspend fun open(@Path("login") login: String, @Body request: OpenWithCodeRequest): Response<ResponseBody>
}
