import android.os.Build
import androidx.annotation.RequiresApi
import okhttp3.OkHttpClient
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import ru.myitschool.work.core.Constants
import java.util.Base64

fun createRetrofit(username: String, password: String): Retrofit {
    val client = OkHttpClient.Builder()
        .build()

    return Retrofit.Builder()
        .baseUrl(Constants.SERVER_ADDRESS)
        .client(client)
        .addConverterFactory(GsonConverterFactory.create())
        .build()
}

fun createAuthHeader(username: String, password: String): String {
    val credentials = "$username:$password"
    return "Basic " + Base64.getEncoder().encodeToString(credentials.toByteArray())
}
